"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkTIUX4OOQcjs = require('./chunk-TIUX4OOQ.cjs');




var _chunkBGMXXFQ4cjs = require('./chunk-BGMXXFQ4.cjs');


var _chunkQY4RIGNMcjs = require('./chunk-QY4RIGNM.cjs');




var _chunkF45I5NLIcjs = require('./chunk-F45I5NLI.cjs');

// src/CrossmintAuthClient.ts






var _commonsdkauth = require('@crossmint/common-sdk-auth');
var _clientsdkbase = require('@crossmint/client-sdk-base');
var CrossmintAuthClient = class _CrossmintAuthClient extends _commonsdkauth.CrossmintAuth {
  constructor(crossmint, apiClient, config = {}) {
    var _a, _b;
    super(crossmint, apiClient, config);
    this.refreshTask = null;
    this.isRefreshing = false;
    this.callbacks = (_a = config.callbacks) != null ? _a : {};
    this.logoutRoute = (_b = config.logoutRoute) != null ? _b : null;
  }
  static from(crossmint, config = {}) {
    const authClient = new _CrossmintAuthClient(crossmint, _commonsdkauth.CrossmintAuth.defaultApiClient(crossmint), config);
    if (typeof window !== "undefined") {
      authClient.handleRefreshAuthMaterial();
    }
    return authClient;
  }
  getUser() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const result = yield this.apiClient.get(`api/${_commonsdkauth.CROSSMINT_API_VERSION}/sdk/auth/user`, {
        headers: {
          "Content-Type": "application/json"
        }
      });
      const user = yield result.json();
      return user;
    });
  }
  storeAuthMaterial(authMaterial) {
    _chunkBGMXXFQ4cjs.setCookie.call(void 0, _commonsdkauth.SESSION_PREFIX, authMaterial.jwt);
    _chunkBGMXXFQ4cjs.setCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX, authMaterial.refreshToken.secret, authMaterial.refreshToken.expiresAt);
  }
  logout() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      var _a, _b;
      try {
        if (this.logoutRoute != null) {
          yield this.logoutFromCustomRoute();
        } else {
          yield this.logoutFromDefaultRoute(_chunkBGMXXFQ4cjs.getCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX));
        }
      } catch (error) {
        console.error(error);
      } finally {
        _chunkBGMXXFQ4cjs.deleteCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX);
        _chunkBGMXXFQ4cjs.deleteCookie.call(void 0, _commonsdkauth.SESSION_PREFIX);
        (_b = (_a = this.callbacks).onLogout) == null ? void 0 : _b.call(_a);
      }
    });
  }
  handleRefreshAuthMaterial(refreshTokenSecret) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      var _a, _b;
      const refreshToken = refreshTokenSecret != null ? refreshTokenSecret : _chunkBGMXXFQ4cjs.getCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX);
      if (refreshToken == null && this.refreshRoute == null || this.isRefreshing) {
        return;
      }
      try {
        this.isRefreshing = true;
        const authMaterial = yield this.refreshAuthMaterial(refreshToken);
        if (this.refreshRoute == null) {
          this.storeAuthMaterial(authMaterial);
        }
        (_b = (_a = this.callbacks).onTokenRefresh) == null ? void 0 : _b.call(_a, authMaterial);
        this.scheduleNextRefresh(authMaterial.jwt);
      } catch (error) {
        console.error(error);
        this.logout();
      } finally {
        this.isRefreshing = false;
      }
    });
  }
  getOAuthUrl(provider) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const result = yield this.apiClient.get(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/social/${provider}/start`, {
        headers: {
          "Content-Type": "application/json"
        }
      });
      const data = yield result.json();
      return data.oauthUrl;
    });
  }
  sendEmailOtp(email) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const result = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/otps/send`, {
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({ email })
      });
      return yield result.json();
    });
  }
  confirmEmailOtp(email, emailId, token) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const queryParams = new URLSearchParams({
        email,
        signinAuthenticationMethod: "email",
        token,
        locale: "en",
        state: emailId,
        callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/we-dont-actually-use-this-anymore`
      });
      const result = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/authenticate?${queryParams}`, {
        headers: {
          "Content-Type": "application/json"
        }
      });
      const resData = yield result.json();
      const callbackUrl = new URL(resData.callbackUrl);
      return callbackUrl.searchParams.get("oneTimeSecret");
    });
  }
  signInWithFarcaster(data) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const queryParams = new URLSearchParams({
        signinAuthenticationMethod: "farcaster",
        callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/callback?isPopup=false`
      });
      const result = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/authenticate?${queryParams}`, {
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify(_chunkF45I5NLIcjs.__spreadProps.call(void 0, _chunkF45I5NLIcjs.__spreadValues.call(void 0, {}, data), {
          domain: data.signatureParams.domain,
          redirect: true,
          callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/callback?isPopup=false`
        }))
      });
      const resData = yield result.json();
      const callbackUrl = new URL(resData.callbackUrl);
      return callbackUrl.searchParams.get("oneTimeSecret");
    });
  }
  signInWithSmartWallet(address) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const queryParams = new URLSearchParams({
        signinAuthenticationMethod: "evm"
      });
      const result = yield this.apiClient.post(
        `${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/crypto_wallets/authenticate/start?${queryParams}`,
        {
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify({ walletAddress: address })
        }
      );
      return yield result.json();
    });
  }
  authenticateSmartWallet(address, signature) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      const queryParams = new URLSearchParams({
        signinAuthenticationMethod: "evm",
        callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/we-dont-actually-use-this-anymore`
      });
      const result = yield this.apiClient.post(
        `${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/crypto_wallets/authenticate?${queryParams}`,
        {
          headers: {
            "Content-Type": "application/json"
          },
          body: JSON.stringify({ walletAddress: address, signature })
        }
      );
      return yield result.json();
    });
  }
  logoutFromCustomRoute() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      if (!this.logoutRoute) {
        throw new Error("Custom logout route is not set");
      }
      return yield fetch(this.logoutRoute, { method: "POST" });
    });
  }
  scheduleNextRefresh(jwt) {
    const jwtExpiration = _chunkQY4RIGNMcjs.getJWTExpiration.call(void 0, jwt);
    if (!jwtExpiration) {
      throw new Error("Invalid JWT");
    }
    const currentTime = Date.now() / 1e3;
    const timeToExpire = jwtExpiration - currentTime - _chunkTIUX4OOQcjs.TIME_BEFORE_EXPIRING_JWT_IN_SECONDS;
    if (timeToExpire > 0) {
      const endTime = Date.now() + timeToExpire * 1e3;
      this.cancelScheduledRefresh();
      this.refreshTask = _clientsdkbase.queueTask.call(void 0, () => this.handleRefreshAuthMaterial(), endTime);
    }
  }
  cancelScheduledRefresh() {
    if (this.refreshTask) {
      this.refreshTask.cancel();
      this.refreshTask = null;
    }
  }
};



exports.CrossmintAuthClient = CrossmintAuthClient;
//# sourceMappingURL=chunk-ILL57KWX.cjs.map